
#include <v8.h>
#include <node.h>
#include <uuid/uuid.h>

using namespace node;
using namespace v8;

class Uuid:ObjectWrap
{
public:

  static Persistent<FunctionTemplate> s_ct;
  static void Init(Handle<Object> target)
  {
    Local<FunctionTemplate> t = FunctionTemplate::New(New);

    s_ct = Persistent<FunctionTemplate>::New(t);
    s_ct->SetClassName(String::NewSymbol("Uuid"));
    s_ct->InstanceTemplate()->SetInternalFieldCount(1);

    NODE_SET_PROTOTYPE_METHOD(s_ct, "random", Random);
    NODE_SET_PROTOTYPE_METHOD(s_ct, "time", Time);

    target->Set(String::NewSymbol("Uuid"),
                s_ct->GetFunction());
  }

  Uuid()
  {
  }

  ~Uuid()
  {
  }

  static Handle<Value> New(const Arguments& args)
  {
    Uuid* hw = new Uuid();
    hw->Wrap(args.This());
    return args.This();
  }

  static Handle<Value> Random(const Arguments& args)
  {
    HandleScope scope;

    uuid_t myid;
    char buf[36+1];

    uuid_generate(myid);
    uuid_unparse(myid, buf);

    Local<String> result = String::New(buf);
    return scope.Close(result);
  }

  static Handle<Value> Time(const Arguments& args)
  {
    HandleScope scope;

    uuid_t myid;
    char buf[36+1];

    uuid_generate_time(myid);
    uuid_unparse(myid, buf);

    Local<String> result = String::New(buf);
    return scope.Close(result);
  }

};

Persistent<FunctionTemplate> Uuid::s_ct;

extern "C" {
  static void init (Handle<Object> target)
  {
    Uuid::Init(target);
  }

  NODE_MODULE(uuid, init);
}
